Bug 1404378 (CVE-2016-9587)

Summary: CVE-2016-9587 Ansible: Compromised remote hosts can lead to running commands on the Ansible controller
Product: [Other] Security Response Reporter: Kurt Seifried <kseifried>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: abutcher, apevec, bleanhar, bmcclain, btotty, carnil, ccoleman, chrisw, cvsbot-xmlrpc, dblechte, dedgar, dmcphers, eedri, esiskonen, gmollett, jcammara, jgoulding, jialiu, jjoyce, jkeck, jlaska, jmckerr, joelsmith, jokerman, jonathan.moore, josborne, jschluet, kbasil, kdreyer, lhh, lmeyer, lpeer, markmc, mgoldboi, michal.skrivanek, mmccomas, notting, rbryant, rcyriac, rhos-maint, sbonazzo, sclewis, sdodson, security-response-team, sgirijan, sisharma, slinaber, slong, ssaha, tdawson, tdecacqu, tvignaud, vbellur, ykaul
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=important,public=20170109,reported=20161212,source=internet,cvss2=6.8/AV:N/AC:M/Au:N/C:P/I:P/A:P,cvss3=6.6/CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H,cwe=CWE-20,openshift-enterprise-3/ansible=affected,qci-1/ansible=wontfix,rhscon-2/ansible=affected,rhes-3.1/ansible=affected,openstack-10/ansible=affected,openstack-11/ansible=affected,fedora-all/ansible=affected,epel-all/ansible=affected,rhev-m-4/ansible=affected
Fixed In Version: ansible 2.1.4, ansible 2.2.1 Doc Type: If docs needed, set a value
Doc Text:
An input validation vulnerability was found in Ansible's handling of data sent from client systems. An attacker with control over a client system being managed by Ansible and the ability to send facts back to the Ansible server could use this flaw to execute arbitrary code on the Ansible server using the Ansible server privileges.
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-06-08 03:04:22 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1410667, 1410669, 1412356, 1412357, 1412370, 1412371, 1427654, 1427655, 1427656, 1447506    
Bug Blocks: 1404380, 1410660, 1415044, 1456591    
Attachments:
Description Flags
Computest's original findings, code and reporting. none

Description Kurt Seifried 2016-12-13 17:06:51 UTC
It is reported that a compromised remote hosts can lead to running commands on the Ansible controller.

Comment 1 James Cammarata 2016-12-19 22:48:52 UTC
Verified attack vectors across devel branch/2.2/2.1 and have created private branches to address the issue across these versions. Due to the holidays, we will hold off on disclosing the vulnerability and will release new candidate versions for stable-2.1 and stable-2.2 branches (2.1.4 RC1 and 2.2.1 RC3 respectively) ASAP in early January.

Comment 2 Jason McKerr 2016-12-20 18:38:34 UTC
I've attached the original reporters research and findings.

Comment 3 Jason McKerr 2016-12-20 18:39:24 UTC
Created attachment 1234010 [details]
Computest's original findings, code and reporting.

Comment 6 James Cammarata 2017-01-09 17:36:33 UTC
Ansible 2.2.1 RC3 and 2.1.4 RC1 were released today, which contain fixes for the security bugs above.

Comment 10 Ken Dreyer (Red Hat) 2017-01-11 20:11:02 UTC
We need Fedora and EPEL tracking bugs for this.

Comment 11 Kurt Seifried 2017-01-11 20:45:31 UTC
Created ansible tracking bugs for this issue:

Affects: fedora-all [bug 1412356]
Affects: epel-all [bug 1412357]

Comment 14 Ken Dreyer (Red Hat) 2017-01-17 03:40:06 UTC
v2.2.1.0 was released upstream today and fixes this bug.

Comment 20 errata-xmlrpc 2017-01-25 20:35:23 UTC
This issue has been addressed in the following products:

  Red Hat OpenStack Platform 10.0 (Newton)

Via RHSA-2017:0195 https://rhn.redhat.com/errata/RHSA-2017-0195.html

Comment 21 errata-xmlrpc 2017-02-07 11:35:56 UTC
This issue has been addressed in the following products:

  Red Hat Gluster Storage 3.1 for RHEL 7

Via RHSA-2017:0260 https://rhn.redhat.com/errata/RHSA-2017-0260.html

Comment 30 errata-xmlrpc 2017-03-06 16:37:16 UTC
This issue has been addressed in the following products:

  Red Hat OpenShift Container Platform 3.2
  Red Hat OpenShift Container Platform 3.3
  Red Hat OpenShift Container Platform 3.4

Via RHSA-2017:0448 https://access.redhat.com/errata/RHSA-2017:0448

Comment 31 errata-xmlrpc 2017-03-14 15:52:01 UTC
This issue has been addressed in the following products:

  Red Hat Storage Console 2 for Red Hat Enteprise Linux 7

Via RHSA-2017:0515 https://access.redhat.com/errata/RHSA-2017:0515

Comment 36 errata-xmlrpc 2017-07-06 07:28:56 UTC
This issue has been addressed in the following products:

  RHEV Engine version 4.1

Via RHSA-2017:1685 https://access.redhat.com/errata/RHSA-2017:1685